! 

  MEMBER

_ABCDllMode_  EQUATE(0)
_ABCLinkMode_ EQUATE(1)

  MAP
  .

  INCLUDE('SwapEIP.inc')

SwapEIPManager.InitControls PROCEDURE !VIRTUAL
! InitControls, this derived method calls SwapContorls to alter the Control element of
! the Eq list and then gets the Fields.List value for use by the UseVar.

FormatPos     long,auto

  code

  ! if no fields then we have problems
  assert(~SELF.Fields &= NULL)

  Self.SwapControls()   ! set Control to correct location
  Self.Eq.Field = 1     ! start at one
  ! step thru the controls and init each
  loop while Self.ListControl{proplist:Exists,Self.Eq.Field}
    get(Self.Eq, Self.Eq.Field)
?   assert(~errorcode())
    ! get the Field list based on the current format field number
    FormatPos = Self.ListControl{proplist:fieldno, Self.Eq.Field}
    get(Self.Fields.List, FormatPos)
?   assert(~errorcode())
    IF ~Self.Eq.Control &= NULL
      Self.Eq.Control.Init(Self.EQ.Field, Self.ListControl, Self.Fields.List.Right)
    ELSE
      Self.ListControl{PROPLIST:textcolor, Self.EQ.Field} = COLOR:GRAYTEXT
    END
    Self.Eq.Field += 1
  END

  return
! end InitControls ----------------------------------------------------------------

SwapEipManager.SwapControls procedure   ! private

FormatPos     long,auto

  code

  ! loop while there is a list box field,
  ! note Self.Eq.Field is set to 1 in the Init method
  loop while Self.ListControl{proplist:exists, Self.Eq.Field}
    get(Self.Eq, Self.Eq.Field)
?   assert(~errorcode())
    ! get the values from the swap queue based on the current field number
    FormatPos = Self.ListControl{proplist:fieldno, Self.Eq.Field}
    get(Self.SwapEq, FormatPos)
?   assert(~errorcode())
    ! assign the control, this actually assigns a class type for the
    ! control create statement
    Self.Eq.Control &= Self.SwapEq.Control
    put(Self.Eq)
?   assert(~errorcode())
    Self.Eq.Field += 1
  end

  return
! end SwapControls ---------------------------------------------------------------------

SwapEipManager.InitSwapQueue procedure

Count   long,auto

  code

  
  assert(records(Self.Eq), 'At least one column must be added through the column specific options')
  ! create new queue
  Self.SwapEq &= new(EditQueue)
  ! step thru the records of the Eq list and assign the values from Eq
  ! to SwapEq, SwapEq will be in the original order the controls were added
! loop Count = 1 to records(Self.Eq)
  Self.Eq.Field = 1
  loop while Self.ListControl{proplist:Exists,Self.Eq.Field}
    get(Self.Eq, Self.Eq.Field)
    if (errorcode())
      Self.Eq.Control &= NULL
      Self.AddControl(Self.Eq.Control, Self.Eq.Field, 0)
      Self.SwapEq.Control &= new(EditEntryClass)
      Self.SwapEq.Field = Self.Eq.Field
      Self.SwapEq.FreeUp = true
      add(Self.SwapEq,  +Self.SwapEq.Field)
?     assert(~errorcode())
    else
      Self.SwapEq.Field = Self.Eq.Field
      Self.SwapEq.FreeUp = false
      Self.SwapEq.Control &= Self.Eq.Control
      add(Self.SwapEq, +Self.SwapEq.Field)
?     assert(~errorcode())
    end
    Self.Eq.Field += 1
  end

  return
! end InitSwapQueue --------------------------------------------------------------

SwapEipManager.KillSwapQueue procedure

x   long,auto

  code

  ! step through the queue and read each element
  loop x = 1 to records(Self.SwapEq)
    get(Self.SwapEq, x)
?   assert(~errorcode())
    ! if FreeUp is true then control was created using the new statement
    ! in the InitSwapQueue method and must be disposed
    if (Self.SwapEq.FreeUp = true)
      dispose(Self.SwapEq.Control)
    end
  end
  ! dump the queue reference
  dispose(Self.SwapEq)

  return
! end KillSwapQueue ---------------------------------------------------------------